/*
Copyright (c) 2019-2023 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>
Kasim Baybikov, <kmbaybikov@basistech.ru>
Tim Tkachev, <tvtkachev@basistech.ru>
Sergey Kisil, <svkisil@digitalenergy.online>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package flipgroup

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/flipgroup"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/dc"
)

func addComputesAfterCreation(ctx context.Context, warnings *dc.Warnings, c *controller.ControllerCfg, compute_ids []interface{}, flipgroupID uint64) {
	if len(compute_ids) == 0 {
		return
	}

	log.Debugf("Adding %v computes to flipgroup [id=%v]...", len(compute_ids), flipgroupID)

	for _, elem := range compute_ids {
		compute_id := uint64(elem.(int))
		req := flipgroup.ComputeAddRequest{
			FLIPGroupID: flipgroupID,
			ComputeID:   compute_id,
		}

		_, err := c.CloudBroker().FLIPGroup().ComputeAdd(ctx, req)
		if err != nil {
			warnings.Add(err)
		}
	}
}

func handleClientIDsUpdate(ctx context.Context, d *schema.ResourceData, c *controller.ControllerCfg, fg *flipgroup.RecordFLIPGroup, warn *dc.Warnings) {
	addedClients := make([]interface{}, 0)
	removedClients := make([]interface{}, 0)

	old_set, new_set := d.GetChange("client_ids")
	oldSlice := old_set.([]interface{})
	newSlice := new_set.([]interface{})

	for _, oldElem := range oldSlice {
		if !containsClient(newSlice, oldElem) {
			removedClients = append(removedClients, oldElem)
		}
	}

	for _, newElem := range newSlice {
		if !containsClient(oldSlice, newElem) {
			addedClients = append(addedClients, newElem)
		}
	}

	log.Debugf("Found client_ids change with %v deletion(s) and %v addition(s) [flipgroupID=%v]", len(removedClients), len(addedClients), fg.ID)

	if len(addedClients) > 0 {
		for _, id := range addedClients {
			req := flipgroup.ComputeAddRequest{
				FLIPGroupID: fg.ID,
				ComputeID:   uint64(id.(int)),
			}

			if _, err := c.CloudBroker().FLIPGroup().ComputeAdd(ctx, req); err != nil {
				warn.Add(err)
			}
		}
	}

	if len(removedClients) > 0 {
		for _, id := range removedClients {
			req := flipgroup.ComputeRemoveRequest{
				FLIPGroupID: fg.ID,
				ComputeID:   uint64(id.(int)),
			}

			if _, err := c.CloudBroker().FLIPGroup().ComputeRemove(ctx, req); err != nil {
				warn.Add(err)
			}
		}
	}
}

func containsClient(set []interface{}, check interface{}) bool {
	for _, elem := range set {
		elemConv := elem.(int)
		checkConv := check.(int)
		if elemConv == checkConv {
			return true
		}
	}

	return false
}
